
import json
import serial
import time
import matplotlib.pyplot as plt
import seaborn as sns
import matplotlib
matplotlib.use('Qt5Agg')
winner=""
final=False

def read_serial_data():
    ser = serial.Serial('/dev/ttyUSB0', 115200)

    data = []
    start_time = time.time()

    while time.time() - start_time < 30:
        if ser.in_waiting > 0:
            line = ser.readline().decode('utf-8').rstrip()
            print(line)
            json_data = json.loads(line)
            data.append(json_data)
            update_bargraph(data)

    ser.close()
    return data

def update_bargraph(data):
    global winner
    global final
    # Extract voltage readings from the JSON data
    voltages1 = [item['Modul1'] for item in data]
    voltages2 = [item['Modul2'] for item in data]

    # Calculate the accumulated sum of the voltages
    accumulated_voltages1 = [sum(voltages1[:i+1]) for i in range(len(voltages1))]
    accumulated_voltages2 = [sum(voltages2[:i+1]) for i in range(len(voltages2))]

    # Clear the previous plot
    plt.clf()

    # Create a bar plot using Seaborn
    sns.set(style='whitegrid')

    # Set the desired x-positions for the bars
    x_positions = [0, 1]  # Adjust these values as needed

    # Plot the bars with specified x-positions
    ax = sns.barplot(x=x_positions, y=[accumulated_voltages1[-1], accumulated_voltages2[-1]], palette=['yellow', 'red'])
    
    # Y Axis Range festlegen
    plt.ylim(0,1500)

    # Set the labels and title
    ax.set_ylabel('')
    ax.set_xlabel('')
    ax.set_xticks(x_positions)
    ax.set_xticklabels(['Spieler 1', 'Spieler 2'])
    ax.set_title('Gesammelte Sonnenenergiepunkte')

    # Mark the higher bar if available
    if accumulated_voltages1[-1] > accumulated_voltages2[-1]:
        ax.patches[0].set_edgecolor('green')
        ax.patches[0].set_linewidth(2)
        if final==True:
           winner="Spieler 1 gewinnt!"
    else:
        ax.patches[1].set_edgecolor('green')
        ax.patches[1].set_linewidth(2)
        if final==True:
           winner="Spieler 2 gewinnt!"

    # Update the plot immediately
    if final==True:
    	ax.text(0,750,winner)
    plt.draw()
    plt.pause(0.020)


# Main program
data = read_serial_data()
final=True
update_bargraph(data)
time.sleep(30)

